<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! class_exists( 'Business_Manager_Setup', false ) ) :

/**
 * Business_Manager_Setup Class.
 */
class Business_Manager_Setup {

	public function __construct() {
		$this->hooks();
	}

	/**
	 * Hook in to actions & filters
	 *
	 * @since 1.0.0
	 */
	public function hooks() {
		add_action( 'admin_enqueue_scripts', array( $this, 'admin_styles' ) );
		add_action( 'admin_enqueue_scripts', array( $this, 'admin_scripts' ) );
		add_action( 'admin_footer', array( $this, 'message_html' ) );
	}

	/**
	 * Init
	 */
	public function admin_styles() {
		$screen = get_current_screen();
		$screen_id = $screen ? $screen->id : '';
		$url 	= BUSINESSMANAGER_URL;
		$v 		= BUSINESSMANAGER_VERSION;
		//if ( in_array( $screen_id, array( 'toplevel_page_business-manager' ) ) ) {
			
			//wp_enqueue_style( 'wp-color-picker' );
			wp_enqueue_style( 'business-manager-ui', $url . 'assets/css/jquery-ui.min.css', $v );
			wp_enqueue_style( 'bm-select2', $url . 'assets/css/select2.min.css', $v );
			wp_enqueue_style( 'business-manager', $url . 'assets/css/bm-admin.css', $v );

		//}

		if ( $screen_id == 'business-manager_page_business-manager-calendar' ) {
			wp_enqueue_style( 'bm-main', $url . 'dist/main.css', $v );
		}

	}

	/**
	 * Init
	 */
	public function admin_scripts() {
		$screen = get_current_screen();
		$screen_id = $screen ? $screen->id : '';
		$url 	= BUSINESSMANAGER_URL;
		$v 		= BUSINESSMANAGER_VERSION;

		wp_enqueue_script( 'bm-select2', $url . 'assets/js/select2.min.js', array( 'jquery' ), $v, true );
		// our last script
		wp_enqueue_script( 'business-manager', $url . 'assets/js/business-manager.js', array( 
			'jquery', 
			'bm-select2',
			), $v, true );
			
			// js options and i18n
			$options = array( 
				'ajax_url' => admin_url( 'admin-ajax.php' ),
				'nonce' => wp_create_nonce( 'bm_nonce' ),
			);

			$i18n = array( 
				// 'todo_remove' => __( 'Sure?', 'business-manager' ),
				// 'todo_tooltip' => __( 'Click to edit', 'business-manager' ),
				// 'todo_placeholder' => __( 'Todo list', 'business-manager' ),
				// 'delete' => __( 'Delete', 'business-manager' ),
				// 'cancel' => __( 'Cancel', 'business-manager' ),
				// 'insert_file' => __( 'Insert File', 'business-manager' ),
				// 'edit_thing' => __( 'Edit Thing', 'business-manager' ),
				// 'add_thing' => __( 'Add Thing', 'business-manager' ),
			);

    		wp_localize_script( 'business-manager', 'bm_l10', array_merge( $options, $i18n ) );

			if ( $screen_id == 'business-manager_page_business-manager-calendar' ) {
				wp_enqueue_script( 'bm-main', $url . 'dist/main.js', array(), $v, true );
				wp_localize_script( 'bm-main' , 'bmApp' , array( 'rest_url' => get_rest_url() ) );
			}
    }


	/**
	 * Message wrapper
	 */
	public function message_html() {
		?>

		<div class="business-manager-message" style="display:none"></div>

		<?php 
	}



}

endif;

return new Business_Manager_Setup();
